<template>
  <div id="main">
    <div v-for="student in students">
      {{ student }}
    </div>

    <button @click="addStudent"> Add Student </button>
    <button @click="editStudent(3)"> Edit Student </button>

    <div v-for="subject in subjects">
      {{ subject }}
    </div>

    <button @click="addSubject"> Add Subject </button>
    <button @click="editSubject(3)"> Edit Subject </button>

  </div> 
</template>

<script>
import {mapGetters} from 'vuex';
import axios from 'axios';

export default {
  data(){
    return {
      editedStudent:{
        'first_name': 'Haris',
        'last_name': 'Selmanovic',
        'email': 'haris.selmanovic@fet.ba',
        'password': 'test123',
        'jmbg': '1212'
      }, 
      editedSubject:{
        'name': 'Matematika2', 
        'token': 'MM2'
      },
    }
  }, 
  
  computed:{
    ...mapGetters([
      'students', 
      'subjects'
    ])
  }, 

  methods:{
    //
    // STUDENTS
    //
    // updateStudents(){ // update the student list with the newest info from database 
    //   var vm = this;
    //   axios.get('http://192.168.220.198:8081/users')
    //   .then(function (response) {
    //     // console.log(response);
    //     vm.$store.commit('setStudents', response.data)
    //   })
    //   .catch((error) => {
    //     console.log(error);
    //     // vm.errors = []
    //     // vm.errors.push(error.response.data.error)
    //   });
    // },
    // addStudent(){
    //   var vm = this;
    //     axios.post('http://192.168.220.198:8081/user', JSON.stringify(this.editedStudent))
    //     .then(function (response) {
    //       // console.log(response);
    //       vm.updateStudents(); 
    //     })
    //     .catch((error) => {
    //       console.log(error);
    //       // vm.errors = []
    //       // vm.errors.push(error.response.data.error)
    //   });
    // }, 
    // editStudent(id){
    //   // var id = this.students.find(stud => stud.id === this.editedStudent);
    //   this.editedStudent.first_name = this.editedStudent.first_name === 'Haris' ? 'Muhamed' : 'Haris';
    //   var vm = this;
    //     axios.put('http://192.168.220.198:8081/user/' + id, JSON.stringify(this.editedStudent))
    //     .then(function (response) {
    //       // console.log(response);
    //       vm.updateStudents(); 
    //     })
    //     .catch((error) => {
    //       console.log(error.code);
    //       // if(error.response.data.error)
    //       // vm.errors = []
    //       // vm.errors.push(error.response.data.error)
    //   });
    // }, 
    //
    // SUBJECTS
    //
    updateSubjects(){ // update the Subject list with the newest info from database 
      var vm = this;
      axios.get('http://192.168.220.198:8081/subjects')
      .then(function (response) {
        // console.log(response);
        vm.$store.commit('setSubjects', response.data)
      })
      .catch((error) => {
        console.log(error);
        // vm.errors = []
        // vm.errors.push(error.response.data.error)
      });
    },

    addSubject(){
      var vm = this;
        axios.post('http://192.168.220.198:8081/subject', JSON.stringify(this.editedSubject))
        .then(function (response) {
          // console.log(response);
          vm.updateSubjects(); 
        })
        .catch((error) => {
          console.log(error);
          // vm.errors = []
          // vm.errors.push(error.response.data.error)
      });
    }, 

    editSubject(id){
      this.editedSubject.name = this.editedSubject.name === 'Matematika2' ? 'Mat2' : 'Matematika2';
      var vm = this;
        axios.put('http://192.168.220.198:8081/subject/' + id, JSON.stringify(this.editedSubject))
        .then(function (response) {
          // console.log(response);
          vm.updateSubjects(); 
        })
        .catch((error) => {
          console.log(error.code);
          // if(error.response.data.error)
          // vm.errors = []
          // vm.errors.push(error.response.data.error)
      });
    }
  },

  created(){
    this.updateStudents(); 
    this.updateSubjects();
  }
}
</script>

<style>
#main{
  height: 100%; 
  width: 100%; 
}
</style>
